;---------------------------------------------------------------
; Shorthand
;
%define B byte
%define W word
%define D dword
%define Q qword
%define T tword

%define ALIGNN(x)  times ($$-$) & (x-1) nop
%define ALIGNZ(x)  times ($$-$) & (x-1) db 0
%define ALIGN(x)   times ($$-$) & (x-1) resb 1

?       equ 0

;---------------------------------------------------------------
; Convenience
;
%macro p 1      ;p 'c'  -- Print a character
	upsh %1
	call emit
%endmacro

%macro $at 2	;$at x,y
	mov dword [xy], %2+(%1<<16)
%endmacro

%macro $color 1	;$color 14
	mov [fore],byte %1
%endmacro


;---------------------------------------------------------------
; Variables, etc.
;
%macro var 2    ; name, value
        call dovar
%1      dd %2
%endmacro

;---------------------------------------------------------------
; Stack
;
%macro dup 0
        sub esi,byte 4
        mov [esi],eax
%endmacro

%macro upsh 1
        dup
        mov eax,%1
%endmacro

%macro upop 1
        mov %1,eax
        lodsd
%endmacro

%macro drop 0
        lodsd
%endmacro

%macro nip 0
        add esi,byte 4
%endmacro

%macro swap 0
        xchg eax,[esi]
%endmacro

%macro over 0
	dup
	mov eax,[esi+4]
%endmacro

%macro rot 0
	xchg eax,[esi]
	xchg eax,[esi+4]
%endmacro

%macro tor 0
	xchg eax,[esi+4]
	xchg eax,[esi]
%endmacro
